# trakerr_client

Trakerr - the Ruby gem for the Trakerr API

Get your application events and errors to Trakerr via the *Trakerr API*.

This SDK is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.0.0
- Package version: 1.0.0
- Build date: 2017-03-13T17:18:49.200-07:00
- Build package: class io.swagger.codegen.languages.RubyClientCodegen

## Installation

### Build a gem

To build the Ruby code into a gem:

```shell
gem build trakerr_client.gemspec
```

Then either install the gem locally:

```shell
gem install ./trakerr_client-1.0.0.gem
```
(for development, run `gem install --dev ./trakerr_client-1.0.0.gem` to install the development dependencies)

or publish the gem to a gem hosting service, e.g. [RubyGems](https://rubygems.org/).

Finally add this to the Gemfile:

    gem 'trakerr_client', '~> 1.0.0'

### Install from Git

If the Ruby gem is hosted at a git repository: https://github.com/GIT_USER_ID/GIT_REPO_ID, then add the following in the Gemfile:

    gem 'trakerr_client', :git => 'https://github.com/GIT_USER_ID/GIT_REPO_ID.git'

### Include the Ruby code directly

Include the Ruby code directly using `-I` as follows:

```shell
ruby -Ilib script.rb
```

## Getting Started

Please follow the [installation](#installation) procedure and then run the following code:
```ruby
# Load the gem
require 'trakerr_client'

api_instance = Trakerr::EventsApi.new

data = Trakerr::AppEvent.new # AppEvent | Event to submit


begin
  #Submit an application event or error to Trakerr
  api_instance.events_post(data)
rescue Trakerr::ApiError => e
  puts "Exception when calling EventsApi->events_post: #{e}"
end

```

## Documentation for API Endpoints

All URIs are relative to *https://www.trakerr.io/api/v1*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*Trakerr::EventsApi* | [**events_post**](docs/EventsApi.md#events_post) | **POST** /events | Submit an application event or error to Trakerr


## Documentation for Models

 - [Trakerr::AppEvent](docs/AppEvent.md)
 - [Trakerr::CustomData](docs/CustomData.md)
 - [Trakerr::CustomDoubleData](docs/CustomDoubleData.md)
 - [Trakerr::CustomStringData](docs/CustomStringData.md)
 - [Trakerr::Error](docs/Error.md)
 - [Trakerr::InnerStackTrace](docs/InnerStackTrace.md)
 - [Trakerr::StackTraceLine](docs/StackTraceLine.md)
 - [Trakerr::StackTraceLines](docs/StackTraceLines.md)
 - [Trakerr::Stacktrace](docs/Stacktrace.md)


## Documentation for Authorization

 All endpoints do not require authorization.

